using System;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;

namespace AndrewConnell.SharePoint.CustomFields {
  public class FieldCollegeFootballTeam : SPFieldMultiColumn {

    public FieldCollegeFootballTeam (SPFieldCollection fields, string fieldName)
      : base(fields, fieldName) {
    }
    public FieldCollegeFootballTeam (SPFieldCollection fields, string typeName, string displayName)
      : base(fields, typeName, displayName) {
    }

    public override object GetFieldValue (string value) {
      if (String.IsNullOrEmpty(value))
        return null;
      return new FieldCollegeFootballTeamValue(value);
    }

    public override BaseFieldControl FieldRenderingControl {
      get {
        BaseFieldControl fieldControl = new FieldCollegeFootballTeamControl();
        fieldControl.FieldName = this.InternalName;
        return fieldControl;
      }
    }

    public override string GetValidatedString (object value) {
      FieldCollegeFootballTeamValue field = null;

      // make sure it's required
      field = (FieldCollegeFootballTeamValue)value;
      if (field != null) {
        // if it's required, make sure they only put a GOOD team in...
        switch (field.SchoolName.Trim().ToLower()) {
          case "florida state":
          case "georgia":
            throw new SPFieldValidationException("Uh... only good teams are permitted.");
        }
      }

      if (value == null)
        return string.Empty;
      else
        return value.ToString();
    }
  }
}